<article class="guide">
    <carousel class="deck container-fluid">
        <slide class="row-fluid">
            <div class="col-sm-3">
                <img src="images/cloudcoreo-logo.png" class="img-responsive">
            </div>
            <div class="col-sm-3">
                <p>CloudCoreo has taken a snapshot of your AWS cloud account and stored the data in this neo4j
                    graph.</p>
            </div>
            <div class="col-sm-3">
                <p>We added some favorite queries to highlight interesting relationships in your AWS cloud account.</p>
            </div>
            <div class="col-sm-3">
                <p>Need more help? Have an idea for an interesting query?</p>
                <a href="https://www.cloudcoreo.com/contact/"
                   style="background:#4E9CAF; border-radius: 5px; color: white; padding: 5px; ">Contact Us</a>
            </div>
        </slide>

        <slide class="row-fluid">
            <div class="col-sm-12">
                <p>This guide will show you some favorite queries:</p>
                <ol class="big">
                    <li>VPC queries</li>
                    <li>Security groups</li>
                    <li>EC2 queries</li>
                </ol>
            </div>
        </slide>
        <slide class="row-fluid">
            <div class="col-sm-3">
                <h5>VPCs queries</h5><br>
                <ol>
                    <li>VPCs canonical view</li>
                    <li>VPCs with instances</li>
                    <li>VPCs with public subnets</li>
                </ol>
                <hr>
                <p>
                    <small>:help</small>&nbsp;<a help-topic="match">MATCH</a>&nbsp;<a help-topic="where">WHERE</a>&nbsp;<a
                        help-topic="return">RETURN</a></p>
            </div>
            <div class="col-sm-9">
                <p class="lead">VPCs with instances and their policies, and their networking configuration:</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match (v:vpc) match ring1=((v)-[:subnet_vpc|:instance_vpc]-(p1))
optional match ring2=((p1)-[:network_acl_association_subnet|:route_table_association_subnet|:instance_security_group|:instance_subnet|:iam_instance_profile_instance|:attachment_instance]-(p2))
optional match ring3=((p2)-[:route_table_route_table_association|:iam_instance_profile_role|:network_acl_network_acl_association|:attachment_network_interface]-(p3))
optional match ring4=((p3)-[:policy_role|:address_network_interface|:network_interface_route|:route_route_table]-(p4))
optional match ring5=((p4)-[:group_policy|:policy_user|:policy_policy_version|:nat_gateway_route|:internet_gateway_route]-(p5))
optional match ring6=((p5)-[:group_user]-(p6))
with ring1 + collect(ring2) + collect(ring3) + collect(ring4) + collect(ring5) + collect(ring6) as results
unwind results as vpc
return vpc</pre>
                </figure>
                <p class="lead">Find VPCs with instances:</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match (vpc:vpc)-[r]-(instance:instance) return r,vpc,instance</pre>
                </figure>
                <p class="lead">Find the VPCs with public instances</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match (n)-[:internet_gateway_route]-(p)-[:route_route_table]-(p2)-[:route_table_route_table_association]-(p3)-[:route_table_association_subnet]-(p4)-[:instance_subnet]-(p5) return n,p,p2,p3,p4,p5</pre>
                </figure>
            </div>
        </slide>
        <slide class="row-fluid">
            <div class="col-sm-3">
                <h5>Find Security groups</h5><br>
                <ol>
                    <li>Security groups usage</li>
                    <li>Unused security groups</li>
                </ol>
                <hr>
                <p>
                    <small>:help</small>&nbsp;<a help-topic="match">MATCH</a></p>
            </div>
            <div class="col-sm-9">
                <p class="lead">Find security groups being used and what is using them</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match path=((n:security_group)-[*1..1]-(a))
with *, relationships(path) as r, count(relationships(path)) as cnt
where cnt > 0
and not a:vpc and not a:owner
return path</pre>
                </figure>
                <p class="lead">List unused security groups</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match path=((n:security_group)-[*1..1]-(a))
with *, relationships(path) as r, count(relationships(path)) as cnt
where cnt > 0
and not a:vpc and not a:owner
with collect(n) as allGroups
match (unused:security_group) where not (unused in allGroups)
return unused</pre>
                </figure>
            </div>
        </slide>
        <slide class="row-fluid">
            <div class="col-sm-3">
                <h5>EC2 queries</h5><br>
                <ol>
                    <li>Public instances</li>
                    <li>Isolated instances</li>
                    <li>Public subnets</li>
                    <li>Lateral movement by keypair</li>
                    <li>Admin instances</li>
                    <li>Lateral movement by keypair to admin instances</li>
                </ol>
            </div>
            <div class="col-sm-9">
                <p class="lead">Find ec2 public instances</p>
                <figure>
          <pre class="pre-scrollable code runnable">match (g:internet_gateway), (s:subnet) match path=((g)-[*1..5]-(s))
where all(x in nodes(path) WHERE not x:vpc and not x:instance and not x:network_interface)
with path, s
match (i:instance) match (s)-[*1..1]-(i)
return path,i</pre>
                </figure>
                <p class="lead">Find isolated public instances</p>
                <figure>
                    <pre class="pre-scrollable code runnable">match (n:instance)-[*]-(p) where not (n:instance)-[:instance_subnet]-() return n,p</pre>
                </figure>
                <p class="lead">Find ec2 public subnets</p>
                <figure>
          <pre class="pre-scrollable code runnable">match (g:internet_gateway), (s:subnet) match path=((g)-[*1..5]-(s))
where all(x in nodes(path) WHERE not x:vpc and not x:instance and not x:network_interface)
return path</pre>
                </figure>
                <p class="lead">Find lateral movement by keypair</p>
                <figure>
          <pre class="pre-scrollable code runnable">
match (g:internet_gateway), (s:subnet) match path=((g)-[*1..5]-(s))
where all(x in nodes(path) WHERE not x:vpc and not x:instance and not x:network_interface)
with path, s
match (i:instance) match path2=((s)-[*1..1]-(i))
with path, path2, i
match (i)-[:instance_key_pair]-(k)-[:instance_key_pair]-(i2)
return path, path2, i, k, i2</pre>
                </figure>
                <p class="lead">Find admin instances</p>
                <figure>
          <pre class="pre-scrollable code runnable">
match (i:instance), (p:policy_version) match path=((i)-[*1..4]-(p))
where p.document =~ '.*iam:*.*'
return path</pre>
                </figure>
                <p class="lead">Find lateral movement by keypair to admin servers</p>
                <figure>
          <pre class="pre-scrollable code runnable">match (g:internet_gateway), (s:subnet) match path=((g)-[*1..5]-(s))
where all(x in nodes(path) WHERE not x:vpc and not x:instance and not x:network_interface)
with path, s
match (i:instance) match path2=((s)-[*1..1]-(i))
with path, path2, i
match path3=((i)-[:instance_key_pair]-(k)-[:instance_key_pair]-(i2))
with path, path2, path3, i2
match (p:policy_version) match path4=((i2)-[*1..4]-(p))
where p.document =~ '.*iam:*.*'
return path, path2, path3, path4</pre>
                </figure>
            </div>
        </slide>
    </carousel>
</article>
